<?php

namespace Modules\DF\Factories;

class Guia{
    
    protected $factory;
    
    public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function getGuides($DTINICIAL, $DTFINAL, $NRINSJURGUIA, $NRNOTAFISC, $CDFILIAL, $STATUS){
        $sql =  "SELECT 
                       FILIEMIT.CDFILIAL AS CDFILIEMIT,
                       FILIEMIT.NMFILIAL AS NMFILIEMIT,
                       FILIRECE.CDFILIAL AS CDFILIRECE,
                       FILIRECE.NMFILIAL AS NMFILIRECE,
                       NF.CDFILIAL AS CDFILIAL,
                       NF.NRLANCTONF AS NRLANCTONF,
                       NF.IDENTRSAIDOP AS IDENTRSAIDOP,
                       NF.NRNOTAFISC AS NRNOTAFISC,
                       NF.CDFEBOSID AS FEBOSID,
                       NF.NRINSJURNF AS NRINSJURGUIA,
                       NF.DTENTRSAID AS DTENTRSAID,
                       NF.DTEMISSAO AS DTEMISSAO,
                       NF.VRNOTAFISC AS VRNOTAFISC
                    FROM NOTAFISCAL NF, 
                         FILIAL FILIEMIT, 
                         FILIAL FILIRECE
                    WHERE 
                        FILIEMIT.CDFILIAL = NF.CDFILIEMIT
                    AND FILIRECE.CDFILIAL = NF.CDFILIRECE
                    AND NF.CDTIPOOPER = '02'
                    AND NF.IDENTRSAIDOP = 'S'
                    AND NF.NRINSJURNF = NVL(:NRINSJURNF, NF.NRINSJURNF)
                    AND NF.NRNOTAFISC = NVL(:NRNOTAFISC, NF.NRNOTAFISC)
                    AND NF.CDFILIRECE = :CDFILIAL
                    AND ((NF.DTENTRSAID BETWEEN :DTINICIAL AND :DTFINAL) OR (:DTINICIAL = 'T'))
                    AND (((NF.CDFEBOSID IS NOT NULL AND :IDSTATUS = 'S') OR (NF.CDFEBOSID IS NULL AND :IDSTATUS = 'N')) OR (:IDSTATUS = 'T'))
                    AND NF.IDSTATUS <> 'D'";
                
        $params = array(
            "CDFILIAL" => $CDFILIAL,
            "DTINICIAL" => $DTINICIAL,
            "DTFINAL" => $DTFINAL,
            "NRNOTAFISC" => $NRNOTAFISC,
            "NRINSJURNF" => $NRINSJURGUIA,
            "IDSTATUS" => $STATUS
        );

        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        $nfWasFound = $query->fetchAll();
        if(isset($nfWasFound) && !empty($nfWasFound)){
            return $nfWasFound;
        }else{
            return false;
        }
    }
    
    public function getProducts($cdfilial, $nrlanctonf){
        $sql =  "SELECT I.CDPRODEMIS AS CDPRODUTO,
                        I.QTITEMPROD AS QTITEMPROD,
                        I.VRUNITITEM AS VRUNITITEM,
                        I.VRTOTAITEM AS VRTOTAITEM,
                        I.NRLOTEESTQ AS NRLOTEESTQ,
                        I.NRSUBLOTE AS NRSUBLOTE,
                        I.CDALMOXARIFE AS CDALMOXARIFE,
                        I.CDLOCALESTOQ AS CDLOCALESTOQ,
                        I.QTITEMPROD AS QTRECEBE
                    FROM ITEMPRODUTO I
                    WHERE CDFILIAL = :CDFILIAL
                    AND NRLANCTONF = :NRLANCTONF";
                
        $params = array(
            "CDFILIAL" => $cdfilial,
            "NRLANCTONF" => $nrlanctonf
        );

        $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        $prodWasFound = $query->fetchAll();
        if(isset($prodWasFound) && !empty($prodWasFound)){
            return $prodWasFound;
        }else{
            return false;
        }
    }
}
