<?php
namespace Financeiro\Logic\ContasReceber\LancamentoContasReceber\Exception;

class ExcecoesContasReceber extends \Geral\Logic\Exception
{
    private $mensagem;

    public function __construct($mensagem,$message = "", $code = 0, \Exception $previous = null)
    {
        parent::__construct($message, $code, $previous);
        $this->mensagem = $mensagem;

    }

    /**
     * Retorna o nome da mensagem cadastrada no Setforms para esta excecao.
     *
     * @return string
     */

    public function getMessageName()
    {
        return $this->mensagem;
    }

    public static function boleto_real()
    {
        throw new self("msg_pbi00015_boletoreal");
    }

    public static function lancamento_fora_periodo()
    {
        throw new self("msg_pbi00015_lancamentoforaperiodo");
    }
	
	public static function conta_possui_ajuste()
    {
        throw new self("msg_pbi00015_contapossuiajuste");
    }
	
	public static function conta_baixada()
    {
        throw new self("msg_pbi00015_contabaixada");
    }
    
    public static function msg_data_emissao()
    {
    	throw new self("msg_pbi00015_dataemissao");
    }
    
    public static function msg_data_vencimento()
    {
    	throw new self("msg_pbi00015_datavencimento");
    }
    
    public static function msg_validaData()
    {
    	throw new self("msg_pbi00015_validadata");
    }

    public static function validapercentualmaior()
    {
        throw new self("msg_pbi00015_validapercentualmaior");
    }
	
    public static function validapercentualmenor()
    {
        throw new self("msg_pbi00015_validapercentualmenor");
    }

    public static function validaValorMaior()
    {
        throw new self("msg_pbi00015_validavalormaior");
    }

    public static function validavalorcontamenor()
    {
        throw new self("msg_pbi00015_validavalorcontamenor");
    }

    public static function validavalorcontamaior()
    {
        throw new self("msg_pbi00015_validavalorcontamaior");
    }

    public static function validaboletoemitido()
    {
        throw new self("msg_pbi00015_validaboletoemitido");
    }

    public static function validaprorrogacao()
    {
        throw new self("msg_pbi00015_validaprorrogacao");
    }
}